package {
	import air.update.ApplicationUpdaterUI;
	import flash.desktop.NativeApplication;
	import flash.display.NativeMenu;
	import flash.display.NativeMenuItem;
	import flash.display.NativeWindow;
	import flash.display.NativeWindowDisplayState;
	import flash.display.NativeWindowInitOptions;
	import flash.display.NativeWindowRenderMode;
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageDisplayState;
	import flash.display.StageQuality;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.events.InvokeEvent;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.events.NativeWindowBoundsEvent;
	import flash.events.NativeWindowDisplayStateEvent;
	import flash.events.NetStatusEvent;
	import flash.events.StageVideoAvailabilityEvent;
	import flash.filesystem.File;
	import flash.filesystem.FileMode;
	import flash.filesystem.FileStream;
	import flash.geom.Rectangle;
	import flash.media.SoundTransform;
	import flash.media.StageVideo;
	import flash.media.StageVideoAvailability;
	import flash.media.Video;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.net.SharedObject;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.ui.Keyboard;
	import flash.utils.clearInterval;
	import flash.utils.setInterval;

	public class pcap extends Sprite {
			public function pcap():void {

				var appUpdater:ApplicationUpdaterUI;

				// コマンドライン引数を取得
				NativeApplication.nativeApplication.addEventListener(InvokeEvent.INVOKE, function (invokeEvent:InvokeEvent):void {

					// var宣言
					var aspectRatio:Number, centerSoundMenuItem:NativeMenuItem, chromeHeight:Number, chromeWidth:Number, domain:String, file:File, frontMenuItem:NativeMenuItem, id:String, leftSoundMenuItem:NativeMenuItem, menu:NativeMenu, menuItem:NativeMenuItem, mute:SoundTransform, muteMenuItem:NativeMenuItem, netCon:NetConnection, netStr:NetStream, netStrState:String, options:NativeWindowInitOptions, playlistUrl:String, reconnectFunction:Function, reconnectInterval:uint, reconnectNumber:Number, reconnectTime:Number, rightSoundMenuItem:NativeMenuItem, so:SharedObject, stageVideo:StageVideo, stf:SoundTransform, stream:FileStream, streamUrl:String, streamUrlSplit:Array, subMenu:NativeMenu, subSubMenu:NativeMenu, title:String, urlLoader:URLLoader, urlRequest:URLRequest, video:Video, videoHeight:Number, videoWidth:Number, window:NativeWindow, windowSize:Number;

					// コマンドライン引数が無い場合は終了
					if (invokeEvent.arguments[0]) {
						if (NativeApplication.nativeApplication.openedWindows.length === 1) {
							// アップデートチェック
							appUpdater = new ApplicationUpdaterUI;
							appUpdater.configurationFile = new File('app:/updateConfig.xml');
							appUpdater.initialize();
						}
					} else {
						if (NativeApplication.nativeApplication.openedWindows.length === 1) {
							stage.nativeWindow.close();
						}
						return;
					}

					// renderModeをDIRECTに設定
					options = new NativeWindowInitOptions;
					options.renderMode = NativeWindowRenderMode.DIRECT;

					// NativeWindowの立ち上げ
					window = new NativeWindow(options);

					// 枠のサイズ
					chromeWidth = window.width - window.stage.stageWidth;
					chromeHeight = window.height - window.stage.stageHeight;

					//メモリ解放
					options = undefined;

					// ウインドウサイズを320x240に設定
					window.width = 320;
					window.height = 240;

					// プレイリストURLをコマンドライン引数から取得
					playlistUrl = invokeEvent.arguments[0];

					// タイトルをコマンドライン引数から取得
					window.title = title = invokeEvent.arguments[1] ? invokeEvent.arguments[1] : 'pcap';

					// クオリティを一番良いのに設定
					window.stage.quality = StageQuality.BEST;

					// 左寄せに設定
					window.stage.align = StageAlign.TOP_LEFT;

					// 固定サイズに設定
					window.stage.scaleMode = StageScaleMode.NO_SCALE;

					// 背景を黒に設定
					window.stage.color = 0x000000;

					// ダブルクリックで最大化
					window.stage.doubleClickEnabled = true;
					window.stage.addEventListener(MouseEvent.DOUBLE_CLICK, function (e:MouseEvent):void {
						if (window.stage.displayState === StageDisplayState.NORMAL) {
							window.stage.displayState = StageDisplayState.FULL_SCREEN_INTERACTIVE;
						} else {
							window.stage.displayState = StageDisplayState.NORMAL;
						}
					});

					// 動画に接続するための変数
					netCon = new NetConnection;
					netCon.connect(null);
					netStr = new NetStream(netCon);

					// サウンドを制御するための変数
					stf = netStr.soundTransform;
					mute = netStr.soundTransform;
					mute.volume = 0;

					// 初期音量の読み込み
					so = SharedObject.getLocal('pcap');

					if (so.data.point !== undefined) {
						window.x = so.data.point.x;
						window.y = so.data.point.y;
					}

					if (so.data.size !== undefined) {
						windowSize = so.data.size;
					}

					if (so.data.volume !== undefined) {
						stf.volume = so.data.volume;
						netStr.soundTransform = stf;
					}

					// 再接続処理
					netStr.addEventListener(NetStatusEvent.NET_STATUS, function (netStatusEvent:NetStatusEvent):void {
						// 接続状態を変数に格納
						if (netStatusEvent.info.code === 'NetStream.Buffer.Full') {
							netStrState = '○';
							window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
						} else if (netStatusEvent.info.code === 'NetStream.Buffer.Empty' || netStatusEvent.info.code === 'NetStream.Buffer.Flush' || netStatusEvent.info.code === 'NetStream.Play.Start') {
							netStrState = '△';
							window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
						} else if (netStatusEvent.info.code === 'NetStream.Play.StreamNotFound') {
							netStrState = '×';
							window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
						} else if (netStatusEvent.info.code === 'NetStream.Video.DimensionChange') {
							// 動画のサイズを変数に格納
							if (stageVideo) {
								videoWidth = stageVideo.videoWidth;
								videoHeight = stageVideo.videoHeight;
							} else {
								videoWidth = video.videoWidth;
								videoHeight = video.videoHeight;
							}

							if (aspectRatio !== videoHeight / videoWidth) {
								// 動画のアスペクト比
								aspectRatio = videoHeight / videoWidth;

								// ウィンドウサイズを動画サイズにリサイズ
								if (windowSize) {
									if (window.minSize.x - chromeWidth <= Math.sqrt(windowSize / aspectRatio) && window.minSize.y - chromeHeight <= Math.sqrt(windowSize * aspectRatio)) {
										window.stage.stageWidth = Math.sqrt(windowSize / aspectRatio);
										window.stage.stageHeight = Math.sqrt(windowSize * aspectRatio);
									} else {
										if ((window.minSize.y - chromeHeight) / (window.minSize.x - chromeWidth) > aspectRatio) {
											window.stage.stageWidth = (window.minSize.y - chromeHeight) / aspectRatio;
											window.stage.stageHeight = window.minSize.y - chromeHeight;
										} else {
											window.stage.stageWidth = window.minSize.x - chromeWidth;
											window.stage.stageHeight = (window.minSize.x - chromeWidth) * aspectRatio;
										}
									}
								} else {
									window.stage.stageWidth = videoWidth;
									window.stage.stageHeight = videoHeight;
								}
							}

							// タイトルを変更
							window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
						}
					});

					netStr.client = new Object;

					// メタ情報を取得した時の処理
					netStr.client.onMetaData = function(obj:Object):void {
						// 動画のサイズを変数に格納
						videoWidth = obj.width;
						videoHeight = obj.height;

						if (aspectRatio !== videoHeight / videoWidth) {
							// 動画のアスペクト比
							aspectRatio = videoHeight / videoWidth;

							// ウィンドウサイズを動画サイズにリサイズ
							if (windowSize) {
								if (window.minSize.x - chromeWidth <= Math.sqrt(windowSize / aspectRatio) && window.minSize.y - chromeHeight <= Math.sqrt(windowSize * aspectRatio)) {
									window.stage.stageWidth = Math.sqrt(windowSize / aspectRatio);
									window.stage.stageHeight = Math.sqrt(windowSize * aspectRatio);
								} else {
									if ((window.minSize.y - chromeHeight) / (window.minSize.x - chromeWidth) > aspectRatio) {
										window.stage.stageWidth = (window.minSize.y - chromeHeight) / aspectRatio;
										window.stage.stageHeight = window.minSize.y - chromeHeight;
									} else {
										window.stage.stageWidth = window.minSize.x - chromeWidth;
										window.stage.stageHeight = (window.minSize.x - chromeWidth) * aspectRatio;
									}
								}
							} else {
								window.stage.stageWidth = videoWidth;
								window.stage.stageHeight = videoHeight;
							}
						}

						// タイトルを変更
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					};

					// プレイリストURLに接続してストリームURLを取得
					if (playlistUrl.indexOf('http://') === 0) {
						urlRequest = new URLRequest(playlistUrl);
						urlLoader = new URLLoader;
						urlLoader.addEventListener(Event.COMPLETE, function (event:Event):void {
							// ストリームURLを取得
							streamUrl = urlLoader.data;

							// メモリ解放
							urlLoader = undefined;
							urlRequest = undefined;

							// ストリームURLからIDとドメインを取得
							streamUrlSplit = streamUrl.split('/');
							domain = streamUrlSplit[2];
							id = streamUrlSplit[4];
							id = id.substr(0, id.indexOf('.'));
							streamUrlSplit = undefined;

							// 動画を再生
							netStr.play(streamUrl);

							// 再接続処理
							reconnectTime;
							reconnectNumber = 1;
							reconnectFunction = function ():void {
								if (netStr) {
									if (netStr.time === reconnectTime) {
										if (++reconnectNumber >= 5) {
											netStr.play(streamUrl);
											reconnectNumber = 1;
										}
									} else {
										reconnectTime = netStr.time;
										reconnectNumber = 1;
									}
								} else {
									clearInterval(reconnectInterval);
									reconnectFunction = undefined;
									reconnectInterval = undefined;
									reconnectNumber = undefined;
									reconnectTime = undefined;
								}
							};
							reconnectInterval = setInterval(reconnectFunction, 1000);
						});
						urlLoader.load(urlRequest);
					} else {
						file = new File(playlistUrl);
						stream = new FileStream;
						stream.open(file, FileMode.READ);
						streamUrl = stream.readUTFBytes(file.size);
						stream.close();

						file = undefined;
						stream = undefined;

						// ストリームURLからIDとドメインを取得
						streamUrlSplit = streamUrl.split('/');
						domain = streamUrlSplit[2];
						id = streamUrlSplit[4];
						id = id.substr(0, id.indexOf('.'));
						streamUrlSplit = undefined;

						// 動画を再生
						netStr.play(streamUrl);

						// 再接続処理
						reconnectTime;
						reconnectNumber = 1;
						reconnectFunction = function ():void {
							if (netStr) {
								if (netStr.time === reconnectTime) {
									if (++reconnectNumber >= 5) {
										netStr.play(streamUrl);
										reconnectNumber = 1;
									}
								} else {
									reconnectTime = netStr.time;
									reconnectNumber = 1;
								}
							} else {
								clearInterval(reconnectInterval);
								reconnectFunction = undefined;
								reconnectInterval = undefined;
								reconnectNumber = undefined;
								reconnectTime = undefined;
							}
						};
						reconnectInterval = setInterval(reconnectFunction, 1000);
					}

					// Videoをステージサイズにする
					video = new Video(window.stage.stageWidth, window.stage.stageHeight);

					// smoothingを有効にする
					video.smoothing = true;

					// videoをステージに追加
					window.stage.addChild(video);

					// StageVideoの再生処理
					window.stage.addEventListener(StageVideoAvailabilityEvent.STAGE_VIDEO_AVAILABILITY, function (stageVideoAvailabilityEvent:StageVideoAvailabilityEvent):void {
						if (stageVideoAvailabilityEvent.availability === StageVideoAvailability.AVAILABLE) {
							if (window.stage.stageVideos.length) {
								stageVideo = window.stage.stageVideos[0];
							} else {
								stageVideo = undefined;
							}
						} else {
							stageVideo = undefined;
						}
						if (stageVideo) {
							stageVideo.viewPort = new Rectangle(0, 0, window.stage.stageWidth, window.stage.stageHeight);
							stageVideo.attachNetStream(netStr);
							video.visible = false;
							video.clear();
						} else {
							video.attachNetStream(netStr);
							video.visible = true;
						}
					});

					// リサイズした時に動画のアスペクト比を維持する処理
					window.stage.addEventListener(Event.RESIZE, function (event:Event):void {
						if (!aspectRatio) {
							return;
						}
						if (stageVideo) {
							if (window.stage.stageHeight / window.stage.stageWidth > aspectRatio) {
								stageVideo.viewPort = new Rectangle(0, (window.stage.stageHeight - (window.stage.stageWidth * aspectRatio)) / 2, window.stage.stageWidth, window.stage.stageWidth * aspectRatio);
							} else {
								stageVideo.viewPort = new Rectangle((window.stage.stageWidth - (window.stage.stageHeight / aspectRatio)) / 2, 0, window.stage.stageHeight / aspectRatio, window.stage.stageHeight);
							}
						} else {
							if (window.stage.stageHeight / window.stage.stageWidth > aspectRatio) {
								video.width = window.stage.stageWidth;
								video.height = window.stage.stageWidth * aspectRatio;
								video.x = 0;
								video.y = (window.stage.stageHeight - video.height) / 2;
							} else {
								video.width = window.stage.stageHeight / aspectRatio;
								video.height = window.stage.stageHeight;
								video.x = (window.stage.stageWidth - video.width) / 2;
								video.y = 0;
							}
						}
					});

					// 最小化から復帰したとき暗転を防ぐ処理
					window.addEventListener(NativeWindowDisplayStateEvent.DISPLAY_STATE_CHANGE, function (nativeWindowDisplayStateEvent:NativeWindowDisplayStateEvent):void {
						if (stageVideo && aspectRatio && nativeWindowDisplayStateEvent.beforeDisplayState === NativeWindowDisplayState.MINIMIZED) {
							stageVideo.viewPort = new Rectangle(0, 0, 0, 0);
							if (window.stage.stageHeight / window.stage.stageWidth > aspectRatio) {
								stageVideo.viewPort = new Rectangle(0, (window.stage.stageHeight - (window.stage.stageWidth * aspectRatio)) / 2, window.stage.stageWidth, window.stage.stageWidth * aspectRatio);
							} else {
								stageVideo.viewPort = new Rectangle((window.stage.stageWidth - (window.stage.stageHeight / aspectRatio)) / 2, 0, window.stage.stageHeight / aspectRatio, window.stage.stageHeight);
							}
						}
					});

					// リサイズした時にウインドウのアスペクト比を維持する処理
					window.addEventListener(NativeWindowBoundsEvent.RESIZING, function (nativeWindowBoundsEvent:NativeWindowBoundsEvent):void {
						if (!aspectRatio) {
							return;
						}
						nativeWindowBoundsEvent.preventDefault();
						if (nativeWindowBoundsEvent.beforeBounds.top !== nativeWindowBoundsEvent.afterBounds.top && nativeWindowBoundsEvent.beforeBounds.bottom === nativeWindowBoundsEvent.afterBounds.bottom && nativeWindowBoundsEvent.beforeBounds.left !== nativeWindowBoundsEvent.afterBounds.left && nativeWindowBoundsEvent.beforeBounds.right === nativeWindowBoundsEvent.afterBounds.right) {
							// TOP_LEFT;
							if ((nativeWindowBoundsEvent.afterBounds.height - chromeHeight) / (nativeWindowBoundsEvent.afterBounds.width - chromeWidth) > aspectRatio) {
								nativeWindowBoundsEvent.currentTarget.width = ((nativeWindowBoundsEvent.afterBounds.height - chromeHeight) / aspectRatio) + chromeWidth;
								nativeWindowBoundsEvent.currentTarget.height = nativeWindowBoundsEvent.afterBounds.height;
							} else {
								nativeWindowBoundsEvent.currentTarget.width = nativeWindowBoundsEvent.afterBounds.width;
								nativeWindowBoundsEvent.currentTarget.height = ((nativeWindowBoundsEvent.afterBounds.width - chromeWidth) * aspectRatio) + chromeHeight;
							}
							nativeWindowBoundsEvent.currentTarget.x = nativeWindowBoundsEvent.afterBounds.right - nativeWindowBoundsEvent.currentTarget.width;
							nativeWindowBoundsEvent.currentTarget.y = nativeWindowBoundsEvent.afterBounds.bottom - nativeWindowBoundsEvent.currentTarget.height;
						} else if (nativeWindowBoundsEvent.beforeBounds.top !== nativeWindowBoundsEvent.afterBounds.top && nativeWindowBoundsEvent.beforeBounds.bottom === nativeWindowBoundsEvent.afterBounds.bottom && nativeWindowBoundsEvent.beforeBounds.left === nativeWindowBoundsEvent.afterBounds.left && nativeWindowBoundsEvent.beforeBounds.right !== nativeWindowBoundsEvent.afterBounds.right) {
							// TOP_RIGHT;
							if ((nativeWindowBoundsEvent.afterBounds.height - chromeHeight) / (nativeWindowBoundsEvent.afterBounds.width - chromeWidth) > aspectRatio) {
								nativeWindowBoundsEvent.currentTarget.width = ((nativeWindowBoundsEvent.afterBounds.height - chromeHeight) / aspectRatio) + chromeWidth;
								nativeWindowBoundsEvent.currentTarget.height = nativeWindowBoundsEvent.afterBounds.height;
							} else {
								nativeWindowBoundsEvent.currentTarget.width = nativeWindowBoundsEvent.afterBounds.width;
								nativeWindowBoundsEvent.currentTarget.height = ((nativeWindowBoundsEvent.afterBounds.width - chromeWidth) * aspectRatio) + chromeHeight;
							}
							nativeWindowBoundsEvent.currentTarget.y = nativeWindowBoundsEvent.afterBounds.bottom - nativeWindowBoundsEvent.currentTarget.height;
						} else if (nativeWindowBoundsEvent.beforeBounds.top === nativeWindowBoundsEvent.afterBounds.top && nativeWindowBoundsEvent.beforeBounds.bottom !== nativeWindowBoundsEvent.afterBounds.bottom && nativeWindowBoundsEvent.beforeBounds.left !== nativeWindowBoundsEvent.afterBounds.left && nativeWindowBoundsEvent.beforeBounds.right === nativeWindowBoundsEvent.afterBounds.right) {
							// BOTTOM_LEFT;
							if ((nativeWindowBoundsEvent.afterBounds.height - chromeHeight) / (nativeWindowBoundsEvent.afterBounds.width - chromeWidth) > aspectRatio) {
								nativeWindowBoundsEvent.currentTarget.width = ((nativeWindowBoundsEvent.afterBounds.height - chromeHeight) / aspectRatio) + chromeWidth;
								nativeWindowBoundsEvent.currentTarget.height = nativeWindowBoundsEvent.afterBounds.height;
							} else {
								nativeWindowBoundsEvent.currentTarget.width = nativeWindowBoundsEvent.afterBounds.width;
								nativeWindowBoundsEvent.currentTarget.height = ((nativeWindowBoundsEvent.afterBounds.width - chromeWidth) * aspectRatio) + chromeHeight;
							}
							nativeWindowBoundsEvent.currentTarget.x = nativeWindowBoundsEvent.afterBounds.right - nativeWindowBoundsEvent.currentTarget.width;
						} else if (nativeWindowBoundsEvent.beforeBounds.top === nativeWindowBoundsEvent.afterBounds.top && nativeWindowBoundsEvent.beforeBounds.bottom !== nativeWindowBoundsEvent.afterBounds.bottom && nativeWindowBoundsEvent.beforeBounds.left === nativeWindowBoundsEvent.afterBounds.left && nativeWindowBoundsEvent.beforeBounds.right !== nativeWindowBoundsEvent.afterBounds.right) {
							// BOTTOM_RIGHT;
							if ((nativeWindowBoundsEvent.afterBounds.height - chromeHeight) / (nativeWindowBoundsEvent.afterBounds.width - chromeWidth) > aspectRatio) {
								nativeWindowBoundsEvent.currentTarget.width = ((nativeWindowBoundsEvent.afterBounds.height - chromeHeight) / aspectRatio) + chromeWidth;
								nativeWindowBoundsEvent.currentTarget.height = nativeWindowBoundsEvent.afterBounds.height;
							} else {
								nativeWindowBoundsEvent.currentTarget.width = nativeWindowBoundsEvent.afterBounds.width;
								nativeWindowBoundsEvent.currentTarget.height = ((nativeWindowBoundsEvent.afterBounds.width - chromeWidth) * aspectRatio) + chromeHeight;
							}
						}
					});

					// ステージをドラッグしてウインドウを移動する処理
					window.stage.addEventListener(MouseEvent.MOUSE_DOWN, function (mouseEvent:MouseEvent):void {
						if (window.stage.displayState === StageDisplayState.NORMAL) {
							window.startMove();
						}
					});

					// 中クリックでミュートする処理
					window.stage.addEventListener(MouseEvent.MIDDLE_CLICK, function (mouseEvent:MouseEvent):void {
						if (muteMenuItem.checked) {
							netStr.soundTransform = stf;
							muteMenuItem.checked = false;
						} else {
							netStr.soundTransform = mute;
							muteMenuItem.checked = true;
						}
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});

					// マウスホイールで音の調整をする処理
					window.stage.addEventListener(MouseEvent.MOUSE_WHEEL, function (mouseEvent:MouseEvent):void {
						if (mouseEvent.delta > 0) {
							stf.volume += mouseEvent.shiftKey ? 0.01 : 0.05;
						} else {
							stf.volume -= mouseEvent.shiftKey ? 0.01 : 0.05;
						}
						if (stf.volume > 1) {
							stf.volume = 1;
						} else if (stf.volume < 0) {
							stf.volume = 0;
						}
						if (!muteMenuItem.checked) {
							netStr.soundTransform = stf;
						}
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});

					// キーボード処理
					window.stage.addEventListener(KeyboardEvent.KEY_DOWN, function (keyboardEvent:KeyboardEvent):void {
						switch (keyboardEvent.keyCode) {
							case 13:
								// ALT+ENTER フルスクリーンの切り替え
								if (keyboardEvent.altKey) {
									if (window.stage.displayState === StageDisplayState.NORMAL) {
										window.stage.displayState = StageDisplayState.FULL_SCREEN_INTERACTIVE;
									} else {
										window.stage.displayState = StageDisplayState.NORMAL;
									}
								} else if (keyboardEvent.ctrlKey) {
									stf.leftToLeft = 1;
									stf.rightToLeft = 0;
									stf.leftToRight = 0;
									stf.rightToRight = 1;
									netStr.soundTransform = stf;
									centerSoundMenuItem.checked = true;
									leftSoundMenuItem.checked = false;
									rightSoundMenuItem.checked = false;
									window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
								}
								break;
							case 37:
								stf.leftToLeft = 1;
								stf.rightToLeft = 1;
								stf.leftToRight = 0;
								stf.rightToRight = 0;
								netStr.soundTransform = stf;
								centerSoundMenuItem.checked = false;
								leftSoundMenuItem.checked = true;
								rightSoundMenuItem.checked = false;
								window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
								break;
							case 38:
								if (keyboardEvent.shiftKey) {
									// SHIFT+UP ウインドウサイズを大きく
									if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
										window.stage.stageWidth += videoWidth * 0.1;
										window.stage.stageHeight += videoHeight * 0.1;
									}
								} else {
									// UP 音量を上げる
									stf.volume += 0.05;
									if (stf.volume > 1) {
										stf.volume = 1;
									} else if (stf.volume < 0) {
										stf.volume = 0;
									}
									if (!muteMenuItem.checked) {
										netStr.soundTransform = stf;
									}
									window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
								}
								break;
							case 39:
								stf.leftToLeft = 0;
								stf.rightToLeft = 0;
								stf.leftToRight = 1;
								stf.rightToRight = 1;
								netStr.soundTransform = stf;
								centerSoundMenuItem.checked = false;
								leftSoundMenuItem.checked = false;
								rightSoundMenuItem.checked = true;
								window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
								break;
							case 40:
								if (keyboardEvent.shiftKey) {
									// SHIFT+DOWN ウインドウサイズを小さく
									if (window.displayState !== NativeWindowDisplayState.MAXIMIZED && (window.minSize.x - chromeWidth <= window.stage.stageWidth - videoWidth * 0.1 && window.minSize.y - chromeHeight <= window.stage.stageHeight - videoHeight * 0.1)) {
										window.stage.stageWidth -= videoWidth * 0.1;
										window.stage.stageHeight -= videoHeight * 0.1;
									}
								} else {
									// DOWN 音量を下げる
									stf.volume -= 0.05;
									if (stf.volume > 1) {
										stf.volume = 1;
									} else if (stf.volume < 0) {
										stf.volume = 0;
									}
									if (!muteMenuItem.checked) {
										netStr.soundTransform = stf;
									}
									window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
								}
								break;
							case 48:
								// 0 初期ウィンドウサイズにリサイズ
								if (windowSize) {
									if (window.minSize.x - chromeWidth <= Math.sqrt(windowSize / aspectRatio) && window.minSize.y - chromeHeight <= Math.sqrt(windowSize * aspectRatio)) {
										window.stage.stageWidth = Math.sqrt(windowSize / aspectRatio);
										window.stage.stageHeight = Math.sqrt(windowSize * aspectRatio);
									} else {
										if ((window.minSize.y - chromeHeight) / (window.minSize.x - chromeWidth) > aspectRatio) {
											window.stage.stageWidth = (window.minSize.y - chromeHeight) / aspectRatio;
											window.stage.stageHeight = window.minSize.y - chromeHeight;
										} else {
											window.stage.stageWidth = window.minSize.x - chromeWidth;
											window.stage.stageHeight = (window.minSize.x - chromeWidth) * aspectRatio;
										}
									}
								} else {
									window.stage.stageWidth = videoWidth;
									window.stage.stageHeight = videoHeight;
								}
								break;
							case 49:
								// 1 50%
								if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
									window.stage.stageWidth = videoWidth * 0.5;
									window.stage.stageHeight = videoHeight * 0.5;
								}
								break;
							case 50:
								// 2 75%
								if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
									window.stage.stageWidth = videoWidth * 0.75;
									window.stage.stageHeight = videoHeight * 0.75;
								}
								break;
							case 51:
								// 3 100%
								if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
									window.stage.stageWidth = videoWidth;
									window.stage.stageHeight = videoHeight;
								}
								break;
							case 52:
								// 4 125%
								if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
									window.stage.stageWidth = videoWidth * 1.25;
									window.stage.stageHeight = videoHeight * 1.25;
								}
								break;
							case 53:
								// 5 150%
								if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
									window.stage.stageWidth = videoWidth * 1.5;
									window.stage.stageHeight = videoHeight * 1.5;
								}
								break;
							case 54:
								// 6 175%
								if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
									window.stage.stageWidth = videoWidth * 1.75;
									window.stage.stageHeight = videoHeight * 1.75;
								}
								break;
							case 55:
								// 7 200%
								if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
									window.stage.stageWidth = videoWidth * 2;
									window.stage.stageHeight = videoHeight * 2;
								}
								break;
							case 67:
								if (keyboardEvent.altKey) {
									// PeerCastの再接続APIにアクセスして再接続
									if (streamUrl && domain && id) {
										urlRequest = new URLRequest('http://' + domain + '/admin?cmd=bump&id=' + id);
										urlLoader = new URLLoader;
										urlLoader.addEventListener(Event.COMPLETE, function (event:Event):void {
											// 再接続
											netStr.play(streamUrl);
										});
										urlLoader.load(urlRequest);
									}
								} else {
									// 再接続
									if (streamUrl) {
										netStr.play(streamUrl);
									}
								}
								break;
							case 77:
								// M ミュート
								if (muteMenuItem.checked) {
									netStr.soundTransform = stf;
									muteMenuItem.checked = false;
								} else {
									netStr.soundTransform = mute;
									muteMenuItem.checked = true;
								}
								window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
								break;
							case 84:
								// T 前面に表示
								window.alwaysInFront = !window.alwaysInFront;
								frontMenuItem.checked = window.alwaysInFront;
								window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
								break;
						}
					});

					// 終了位置を記憶
					window.addEventListener(Event.CLOSING, function (event:Event):void {
						so = SharedObject.getLocal('pcap');
						so.data.point = {x: window.x, y: window.y};
						so.flush();
						so = undefined;
					});

					// ウインドウを閉じたときにメモリ解放
					window.addEventListener(Event.CLOSE, function (event:Event):void {
						// ストリームを切断
						netStr.close();

						aspectRatio = undefined;
						centerSoundMenuItem = undefined;
						chromeHeight = undefined;
						chromeWidth = undefined;
						domain = undefined;
						frontMenuItem = undefined;
						id = undefined;
						leftSoundMenuItem = undefined;
						menu = undefined;
						mute = undefined;
						muteMenuItem = undefined;
						netCon = undefined;
						netStr = undefined;
						netStrState = undefined;
						playlistUrl = undefined;
						rightSoundMenuItem = undefined;
						stageVideo = undefined;
						stf = undefined;
						streamUrl = undefined;
						title = undefined;
						video = undefined;
						videoHeight = undefined;
						videoWidth = undefined;
						window = undefined;
						windowSize = undefined;

						if (NativeApplication.nativeApplication.openedWindows.length === 2) {
							stage.nativeWindow.close();
						}
					});

					// 右クリックでメニュー表示
					window.stage.addEventListener(MouseEvent.RIGHT_CLICK, function (mouseEvent:MouseEvent):void {
						menu.display(window.stage, mouseEvent.stageX, mouseEvent.stageY);
					});

					// メニューの生成
					menu = new NativeMenu;

					subMenu = new NativeMenu;

					menuItem = new NativeMenuItem('初期サイズ');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						// 初期ウィンドウサイズにリサイズ
						if (windowSize) {
							if (window.minSize.x - chromeWidth <= Math.sqrt(windowSize / aspectRatio) && window.minSize.y - chromeHeight <= Math.sqrt(windowSize * aspectRatio)) {
								window.stage.stageWidth = Math.sqrt(windowSize / aspectRatio);
								window.stage.stageHeight = Math.sqrt(windowSize * aspectRatio);
							} else {
								if ((window.minSize.y - chromeHeight) / (window.minSize.x - chromeWidth) > aspectRatio) {
									window.stage.stageWidth = (window.minSize.y - chromeHeight) / aspectRatio;
									window.stage.stageHeight = window.minSize.y - chromeHeight;
								} else {
									window.stage.stageWidth = window.minSize.x - chromeWidth;
									window.stage.stageHeight = (window.minSize.x - chromeWidth) * aspectRatio;
								}
							}
						} else {
							window.stage.stageWidth = videoWidth;
							window.stage.stageHeight = videoHeight;
						}
					});
					menuItem.keyEquivalent = '0';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('50%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						window.stage.stageWidth = videoWidth * 0.5;
						window.stage.stageHeight = videoHeight * 0.5;
					});
					menuItem.keyEquivalent = '1';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('75%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						window.stage.stageWidth = videoWidth * 0.75;
						window.stage.stageHeight = videoHeight * 0.75;
					});
					menuItem.keyEquivalent = '2';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('100%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						window.stage.stageWidth = videoWidth;
						window.stage.stageHeight = videoHeight;
					});
					menuItem.keyEquivalent = '3';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('125%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						window.stage.stageWidth = videoWidth * 1.25;
						window.stage.stageHeight = videoHeight * 1.25;
					});
					menuItem.keyEquivalent = '4';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('150%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						window.stage.stageWidth = videoWidth * 1.5;
						window.stage.stageHeight = videoHeight * 1.5;
					});
					menuItem.keyEquivalent = '5';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('175%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						window.stage.stageWidth = videoWidth * 1.75;
						window.stage.stageHeight = videoHeight * 1.75;
					});
					menuItem.keyEquivalent = '6';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('200%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						window.stage.stageWidth = videoWidth * 2;
						window.stage.stageHeight = videoHeight * 2;
					});
					menuItem.keyEquivalent = '7';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					subMenu.addItem(new NativeMenuItem(null, true));

					menuItem = new NativeMenuItem('+10%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						if (window.displayState !== NativeWindowDisplayState.MAXIMIZED) {
							window.stage.stageWidth += videoWidth * 0.1;
							window.stage.stageHeight += videoHeight * 0.1;
						}
					});
					menuItem.keyEquivalent = 'UP';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('-10%');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						if (window.displayState !== NativeWindowDisplayState.MAXIMIZED && (window.minSize.x - chromeWidth <= window.stage.stageWidth - videoWidth * 0.1 && window.minSize.y - chromeHeight <= window.stage.stageHeight - videoHeight * 0.1)) {
							window.stage.stageWidth -= videoWidth * 0.1;
							window.stage.stageHeight -= videoHeight * 0.1;
						}
					});
					menuItem.keyEquivalent = 'DOWN';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menu.addSubmenu(subMenu, '拡大率');

					subMenu = new NativeMenu;

					menuItem = new NativeMenuItem('上げる');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						stf.volume += 0.05;
						if (stf.volume > 1) {
							stf.volume = 1;
						} else if (stf.volume < 0) {
							stf.volume = 0;
						}
						if (!muteMenuItem.checked) {
							netStr.soundTransform = stf;
						}
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});
					menuItem.keyEquivalent = 'up';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('下げる');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						stf.volume -= 0.05;
						if (stf.volume > 1) {
							stf.volume = 1;
						} else if (stf.volume < 0) {
							stf.volume = 0;
						}
						if (!muteMenuItem.checked) {
							netStr.soundTransform = stf;
						}
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});
					menuItem.keyEquivalent = 'down';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					muteMenuItem = new NativeMenuItem('ミュート');
					muteMenuItem.addEventListener(Event.SELECT, function (event:Event):void {
						if (muteMenuItem.checked) {
							netStr.soundTransform = stf;
							muteMenuItem.checked = false;
						} else {
							netStr.soundTransform = mute;
							muteMenuItem.checked = true;
						}
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});
					muteMenuItem.keyEquivalent = 'm';
					muteMenuItem.keyEquivalentModifiers = [];
					subMenu.addItem(muteMenuItem);

					subMenu.addItem(new NativeMenuItem(null, true));

					subSubMenu = new NativeMenu;

					centerSoundMenuItem = new NativeMenuItem('中央');
					centerSoundMenuItem.addEventListener(Event.SELECT, function (event:Event):void {
						stf.leftToLeft = 1;
						stf.rightToLeft = 0;
						stf.leftToRight = 0;
						stf.rightToRight = 1;
						netStr.soundTransform = stf;
						centerSoundMenuItem.checked = true;
						leftSoundMenuItem.checked = false;
						rightSoundMenuItem.checked = false;
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});
					centerSoundMenuItem.keyEquivalent = 'enter';

					subSubMenu.addItem(centerSoundMenuItem);

					leftSoundMenuItem = new NativeMenuItem('左');
					leftSoundMenuItem.addEventListener(Event.SELECT, function (event:Event):void {
						stf.leftToLeft = 1;
						stf.rightToLeft = 1;
						stf.leftToRight = 0;
						stf.rightToRight = 0;
						netStr.soundTransform = stf;
						centerSoundMenuItem.checked = false;
						leftSoundMenuItem.checked = true;
						rightSoundMenuItem.checked = false;
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});
					leftSoundMenuItem.keyEquivalent = 'left';
					leftSoundMenuItem.keyEquivalentModifiers = [];
					subSubMenu.addItem(leftSoundMenuItem);

					rightSoundMenuItem = new NativeMenuItem('右');
					rightSoundMenuItem.addEventListener(Event.SELECT, function (event:Event):void {
						stf.leftToLeft = 0;
						stf.rightToLeft = 0;
						stf.leftToRight = 1;
						stf.rightToRight = 1;
						netStr.soundTransform = stf;
						centerSoundMenuItem.checked = false;
						leftSoundMenuItem.checked = false;
						rightSoundMenuItem.checked = true;
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});
					rightSoundMenuItem.keyEquivalent = 'right';
					rightSoundMenuItem.keyEquivalentModifiers = [];
					subSubMenu.addItem(rightSoundMenuItem);

					subMenu.addSubmenu(subSubMenu, 'バランス');

					menu.addSubmenu(subMenu, '音量');

					subMenu = new NativeMenu;

					menuItem = new NativeMenuItem('ストリームを再接続');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						// 再接続
						if (streamUrl) {
							netStr.play(streamUrl);
						}
					});
					menuItem.keyEquivalent = 'c';
					menuItem.keyEquivalentModifiers = [];
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('チャンネルを再接続');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						// PeerCastの再接続APIにアクセスして再接続
						if (streamUrl && domain && id) {
							urlRequest = new URLRequest('http://' + domain + '/admin?cmd=bump&id=' + id);
							urlLoader = new URLLoader;
							urlLoader.addEventListener(Event.COMPLETE, function (event:Event):void {
								// 再接続
								netStr.play(streamUrl);
							});
							urlLoader.load(urlRequest);
						}
					});
					menuItem.keyEquivalent = 'c';
					menuItem.keyEquivalentModifiers = [Keyboard.ALTERNATE];
					subMenu.addItem(menuItem);

					menu.addSubmenu(subMenu, '再接続');

					subMenu = new NativeMenu;

					menuItem = new NativeMenuItem('動画のサイズを初期のサイズに設定');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						so = SharedObject.getLocal('pcap');
						so.data.size = undefined;
						so.flush();
						so = undefined;
					});
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('現在のサイズを初期のサイズに設定');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						so = SharedObject.getLocal('pcap');
						so.data.size = window.stage.stageWidth * window.stage.stageHeight;
						so.flush();
						so = undefined;
					});
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('現在の状態を初期の状態に設定');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						so = SharedObject.getLocal('pcap');
						so.data.state = {
							mute: muteMenuItem.checked,
							front: frontMenuItem.checked,
							sound: centerSoundMenuItem.checked ? 'center' :
								(leftSoundMenuItem.checked ? 'left' :
									(rightSoundMenuItem.checked ? 'right' : 'center')
								)
						};
						so.flush();
						so = undefined;
					});
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('現在の音量を初期の音量に設定');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						so = SharedObject.getLocal('pcap');
						so.data.volume = stf.volume;
						so.flush();
						so = undefined;
					});
					subMenu.addItem(menuItem);

					menuItem = new NativeMenuItem('pcapを最新バージョンに更新');
					menuItem.addEventListener(Event.SELECT, function (event:Event):void {
						appUpdater.checkNow();
					});
					subMenu.addItem(menuItem);

					menu.addSubmenu(subMenu, '設定');

					menu.addItem(new NativeMenuItem(null, true));

					frontMenuItem = new NativeMenuItem('常に手前に表示');
					frontMenuItem.addEventListener(Event.SELECT, function (event:Event):void {
						window.alwaysInFront = !window.alwaysInFront;
						frontMenuItem.checked = window.alwaysInFront;
						window.title = netStrState + title + ' vol:' + Math.round(stf.volume * 100) + (leftSoundMenuItem.checked ? ' L' : '') + (rightSoundMenuItem.checked ? ' R' : '') + (muteMenuItem.checked ? ' mute' : '') + (frontMenuItem.checked ? ' front' : '') + ' (' + videoWidth + 'x' + videoHeight + ')';
					});
					frontMenuItem.keyEquivalent = 't';
					frontMenuItem.keyEquivalentModifiers = [];
					menu.addItem(frontMenuItem);

					if (so.data.state !== undefined) {
						switch (so.data.state.sound) {
							case 'center':
								stf.leftToLeft = 1;
								stf.rightToLeft = 0;
								stf.leftToRight = 0;
								stf.rightToRight = 1;
								netStr.soundTransform = stf;
								centerSoundMenuItem.checked = true;
								break;
							case 'left':
								stf.leftToLeft = 1;
								stf.rightToLeft = 1;
								stf.leftToRight = 0;
								stf.rightToRight = 0;
								netStr.soundTransform = stf;
								leftSoundMenuItem.checked = true;
								break;
							case 'right':
								stf.leftToLeft = 0;
								stf.rightToLeft = 0;
								stf.leftToRight = 1;
								stf.rightToRight = 1;
								netStr.soundTransform = stf;
								rightSoundMenuItem.checked = true;
								break;
						}

						if (so.data.state.mute) {
							netStr.soundTransform = mute;
							muteMenuItem.checked = true;
						}

						if (so.data.state.front) {
							window.alwaysInFront = true;
							frontMenuItem.checked = true;
						}
					} else {
						centerSoundMenuItem.checked = true;
					}

					so = undefined;
					menuItem = undefined;
					subMenu = undefined;
					subSubMenu = undefined;

					// ウインドウをアクティブ
					window.activate();
				});
			}
	}
}
